/*
   Siag, Scheme In A Grid
   Copyright (C) 2000  Ulric Eriksson <ulric@siag.nu>
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
 */

#include "../config.h"

#ifdef HAVE_LIBSQLITE

/* Highly experimental! */

#include <stdio.h>
#include <stdlib.h>
#include <sqlite.h>
#include "../siod/siod.h"
#include "calc.h"

static char *database = "siag";

#define FAIL(db, msg) {\
	fprintf(stderr, "error '%s'\n", msg);\
	sqlite_close(db);\
	return NIL;\
}

struct cb_data {
	buffer *buf;		/* buffer we're filling in */
	int sht, row, col;	/* where */
	int r;			/* row within query result */
	LISP res;		/* to be returned from function */
};

static int store_result(void *data, int n, char **p, char **q)
{
	struct cb_data *cbd = (struct cb_data *)data;

	int i;
	cval val;

	val.number = 0;

	for (i = 0; i < n; i++) {
		if (cbd->res == NIL) {
			cbd->res = strcons(strlen(p[i]), p[i]);
		} else {
			ins_data(cbd->buf, siod_interpreter,
				p[i], val, MTEXT, cbd->sht,
				cbd->row+cbd->r, cbd->col+i);
		}
	}
	cbd->r++;
	return 0;
}

static LISP lsqlite_query(LISP query)
{
	int n;
	char *q = get_c_string(query);
	sqlite *db;
	char *errmsg;
	struct cb_data cbd;

	get_siod_coords(&cbd.row, &cbd.col, &cbd.sht, &cbd.buf);
	cbd.r = 0;
	cbd.res = NIL;
	db = sqlite_open(database, 0666, &errmsg);
	if (!db) FAIL(db, errmsg);
	n = sqlite_exec(db, q, store_result, &cbd, &errmsg);
	if (n != 0) FAIL(db, errmsg);
	sqlite_close(db);
	return cbd.res;
}

void init_sqlite(void)
{
	init_subr_1("sqlite_query", lsqlite_query);
}

#else

void init_sqlite(void)
{
	;
}

#endif	/* SQLITE */

